
!SSSession methodsFor: 'request handling' stamp: 'bf 5/25/2005 13:37'!
createRootFromRequest: aRequest
	"Make a project home page for projectname.html"
	| accessPath frame |
	frame _ super createRootFromRequest: aRequest.
	accessPath _ aRequest accessPath.
	accessPath size > 0 ifTrue: [
		(self projectNamed: (accessPath first copyUpToLast: $.))
			ifNotNilDo: [:project | frame setComponent: project view]].
	^ frame! !

!SSSession methodsFor: 'request handling' stamp: 'bf 12/16/2004 19:42'!
enterSession: aBlock
	^ monitor critical: [self withEscapeContinuation: [self withErrorHandler: [
		self alwaysRedirect ifTrue: [self redirect].
		aBlock value]]]! !

!SSSession methodsFor: 'request handling' stamp: 'bf 12/15/2004 15:41'!
enterSessionWithRequest: aRequest
	" This method is overridden to hock-in requests coming from monticello, it isn't used while being in a seaside session. "

	^self withRequest: aRequest do: [ 
		aRequest method = 'PUT'
			ifTrue: [ self handleProject: #putRequest: ]
			ifFalse: [
				(self wantsSessionForRequest: aRequest)
					ifTrue: [ super enterSessionWithRequest: aRequest ]
					ifFalse: [ self handleProject: #getRequest: ] ] ]! !

!SSSession methodsFor: 'request handling' stamp: 'bf 5/26/2005 18:32'!
handleProject: aSymbol 
	" This method looks-up the project if outside a seaside-session and if successfull initializes a stateless environment with error-handler and escape continuation that can be used similarly while while inside a session. "

	^self withErrorHandler: [
		self withEscapeContinuation: [
			| accessPath project |
			accessPath _ self request accessPath.
			project _ self projectNamed: accessPath first.
			project isNil 
				ifTrue: [ 
					accessPath first = 'feed.rss'
						ifTrue: [ self getRss ]
						ifFalse: [ self errorNotFound: accessPath first ] ]
				ifFalse: [ self perform: aSymbol with: project ] ] ]! !

!SSSession methodsFor: 'private' stamp: 'bf 5/25/2005 13:36'!
projectNamed: aString

	^(self repository projectAt: aString) ifNotNilDo: [:project |
		(self isAllowed: SSAccessPolicy read in: project)
			ifTrue: [project]]! !

!SSSession methodsFor: 'request handling' stamp: 'bf 5/25/2005 13:39'!
wantsSessionForRequest: aRequest
	"We want to start a regular session if the path is empty or a project home page (projectname.html)"
	| accessPath fileName baseName |
	accessPath _ aRequest accessPath.
	accessPath size = 0 ifTrue: [^true].
	accessPath size > 1 ifTrue: [^false].
	fileName _ accessPath first.
	(fileName endsWith: '.html') ifFalse: [^false].
	baseName _ fileName copyUpToLast: $. .
	^ (self projectNamed: baseName) notNil! !
