
!SSSession methodsFor: 'request handling' stamp: 'lr 2/15/2004 16:55'!
enterSessionWithRequest: aRequest
	" This method is overridden to hock-in requests coming from monticello, it isn't used while being in a seaside session. "

	^self withRequest: aRequest do: [ 
		aRequest method = 'PUT'
			ifTrue: [ self handleProject: #putRequest: ]
			ifFalse: [
				aRequest accessPath notEmpty
					ifTrue: [ self handleProject: #getRequest: ]
					ifFalse: [ super enterSessionWithRequest: aRequest ] ] ]! !

!SSSession methodsFor: 'request handling' stamp: 'lr 2/15/2004 23:08'!
handleProject: aSymbol 
	" This method looks-up the project if outside a seaside-session and if successfull initializes a stateless environment with error-handler and escape continuation that can be used similarly while while inside a session. "

	| accessPath project |
	accessPath _ self request accessPath.
	project _ self repository projectAt: accessPath first.
	^self withErrorHandler: [
		self withEscapeContinuation: [
			project isNil 
				ifTrue: [ 
					accessPath first = 'feed.rss'
						ifTrue: [ self getRss ]
						ifFalse: [ self errorNotFound: accessPath first ] ]
				ifFalse: [ self perform: aSymbol with: project ] ] ]! !
